<?php
/*
Plugin Name: Zitate
Plugin URI: http://www.zitate-online.de/servicetagestext/
Description: Zeigt das Zitat des Tages bzw. ein Zufallszitat an. Hier k&ouml;nnen Sie das Plugin <a href="options-general.php?page=zitat.php">konfigurieren</a>.
Author: Gunther Krauss
Version: 1.0
Author URI: http://webwork.guntherkrauss.de/
*/ 


class www_zitate_online_de {

  var $_position_manuell = 3;
  var $_position_footer = 1;
  var $_position_meta = 2;
  
  var $_position_standard = 2;
  var $_position=2;
  var $_position_name = 'www_zitate_online_de_position';
  
  
  
  var $_anzeige_tagestext = 1;
  var $_anzeige_zufallstext = 2;
  var $_anzeige = 3;
  var $_anzeige_standard = 3;
  var $_anzeige_name = 'www_zitate_online_de_anzeige';

  var $_ueberschrift = 1;
  var $_ueberschrift_standard = 1;
  var $_ueberschrift_name = 'www_zitate_online_de_ueberschrift';
 
  var $_autorbild = 1;
  var $_autorbild_standard = 1;
  var $_autorbild_name = 'www_zitate_online_de_autorbild';
  
  var $_ueberschrift_tagestext = '<h2>Zitat des Tages</h2>';
  var $_ueberschrift_zufallstext = '<h2>Zufallszitat</h2>';
  
  var $_url_tagestext = 'http://www.zitate-online.de/zitatdestages.txt';
  var $_url_zufallstext = 'http://www.zitate-online.de/zufallszitat.txt.php';

  var $_url_tagestext_autor = 'http://www.zitate-online.de/zitatdestages_autor.txt';
  var $_url_zufallstext_autor = 'http://www.zitate-online.de/zufallszitat_autor.txt.php';

/* interne Funktionen */

  function setzeOptionen ()
  {
    update_option($this->_position_name,(string)$this->_position);
    update_option($this->_anzeige_name, (($this->_anzeige) ? (string)$this->_anzeige : '-'));
    update_option($this->_ueberschrift_name, (($this->_ueberschrift) ? 'ja' : 'nein') );
    update_option($this->_autorbild_name, (($this->_autorbild) ? 'ja' : 'nein') );
  }
  
  
  function holeOptionen ()
  {
    $pos = get_option($this->_position_name);
    $anz = get_option($this->_anzeige_name);
    $ueb = get_option($this->_ueberschrift_name);
    $aut = get_option($this->_autorbild_name);
    $this->_position = ($pos!='') ? (int)$pos : $this->_position_standard;
    $this->_anzeige = ($anz!='') ? (($anz !='-') ? (int)$anz : 0)  : $this->_anzeige_standard;
    $this->_ueberschrift = ($ueb!='') ? (($ueb=='ja') ? 1 : 0 ) : $this->_ueberschrift_standard;
    $this->_autorbild = ($aut!='') ? (($aut=='ja') ? 1 : 0 ) : $this->_autorbild_standard;
  }
  
  function holePosition() {
    return $this->_position;
  }


/* Konstruktor */
  
  function www_zitate_online_de(){
  
    $this->holeOptionen();
    
    switch ($this->holePosition()) 
    {
      case $this->_position_manuell : break;
      case $this->_position_footer : 
      {
    	add_action('wp_footer', array(&$this,'textanzeige'));
    	break;
      };
      case $this->_position_meta :      {
    	add_action('wp_meta', array(&$this,'textanzeige'));
    	break;
      };
    };
	
   add_action('admin_menu', array(&$this,'plugin_admin'));
  }


/* Frontend */
  function text_des_tages ()
  {
   if ($this->_autorbild) 
   {
     $text = file_get_contents($this->_url_tagestext_autor);
   }
   else 
   {
     $text = file_get_contents($this->_url_tagestext);
   };
   if($text)
   {
    echo $text;
   };
  }

  function zufallstext ()
  {
   if ($this->_autorbild) 
   {
     $text = file_get_contents($this->_url_zufallstext_autor);
   }
   else 
   {
     $text = file_get_contents($this->_url_zufallstext);
   };
   if($text)
   {
    echo $text;
   };
  }
  
  function textanzeige()
  {
    if($this->_anzeige)
    {
      echo ($this->_position == $this->_position_meta) ? '<li id="www_zitate_online_de_zitat" style="margin-top:1ex;">' : '<div id="www_zitate_online_de_zitat">';
    };
    if ($this->_anzeige & $this->_anzeige_tagestext)
    {
      echo ($this->_ueberschrift) ? $this->_ueberschrift_tagestext : '';
      $this->text_des_tages();
    };
    if ($this->_anzeige & $this->_anzeige_zufallstext)
    {
      echo ($this->_ueberschrift) ? $this->_ueberschrift_zufallstext : '';
      $this->zufallstext();
    };
    if($this->_anzeige)
    {
      echo ($this->_position == $this->_position_meta) ? '</li>' : '</div>'; 
    };
  }

  function textanzeige_manuell()
  {
    if($this->_position == $this->_position_manuell)
    {
      $this->textanzeige();
    };
  }

/* Administration */

  function plugin_admin() {
    if (function_exists('add_options_page')) 
    {
     add_options_page('Zitate', 'Zitate', 8, basename(__FILE__), array(&$this,'admin_subpanel'));
    };
  }

  function admin_subpanel () {
    echo '
    <h1>Konfiguration der Zitatanzeige</h1>';
 
   if(array_key_exists('speichern',$_POST) && $_POST['speichern']='Speichern')
   {
   $this->_position = (array_key_exists('methode',$_POST)) ? (int)$_POST['methode'] : 0;
   $this->_anzeige = (array_key_exists('tagestext',$_POST) || array_key_exists('zufallstext',$_POST)) ? (int)$_POST['tagestext'] + (int)$_POST['zufallstext'] : 0;
   $this->_ueberschrift = (array_key_exists('ueberschrift',$_POST)) ? (int)$_POST['ueberschrift'] : 0;
   $this->_autorbild = (array_key_exists('autorbild',$_POST)) ? (int)$_POST['autorbild'] : 0;
   $this->setzeOptionen();
   echo '<p>Einstellungen wurden gespeichert!</p>';
   $this->holeOptionen();
   };
 
 
   echo '
  <form action="#" method="post">
   <fieldset>
     <legend>Was soll angezeigt werden?</legend>
     <input type="checkbox" name="tagestext" id="tagestext" value="'.$this->_anzeige_tagestext.'" '.(($this->_anzeige & $this->_anzeige_tagestext) ? ' checked="checked"' : '').' /> <label for="tagestext">Zitat des Tages</label><br/>
     <input type="checkbox" name="zufallstext"  id="zufallstext" value="'.$this->_anzeige_zufallstext.'" '.(($this->_anzeige & $this->_anzeige_zufallstext) ? ' checked="checked"' : '').'/> <label for="zufallstext">Zufallszitat</label>
   </fieldset>
   <fieldset>
     <legend>Wo sollen die Zitate angezeigt werden?</legend>
     <input type="radio" name="methode" id="gk_manuell" value="'.$this->_position_manuell.'" '.(($this->_position == $this->_position_manuell) ? ' checked="checked"' : '').'/> <label for="gk_manuell">An beliebiger Stelle (daf&uuml;r m&uuml;ssen Sie ein Template &auml;ndern)</label><br/>
     <input type="radio" name="methode" id="gk_footer" value="'.$this->_position_footer.'"'.(($this->_position == $this->_position_footer) ? ' checked="checked"' : '').'/> <label for="gk_footer">Am Ende der Seite</label><br/>
     <input type="radio" name="methode" id="gk_meta" value="'.$this->_position_meta.'"'.(($this->_position == $this->_position_meta) ? ' checked="checked"' : '').'/> <label for="gk_meta">In der Sidebar</label><br/>
     <span style="font-size:90%;">
      Um die Zitate an beliebiger Stelle anzuzeigen, m&uuml;sssen Sie an der gew&uuml;nschten Stelle in dem Template (z.B. sidebar.php) Folgendes einf&uuml;gen:<br />
      <code>&lt;?php www_zitate_online_de_zitat();?&gt;</code><br/>
      Wenn Sie <em>am Ende der Seite</em> oder <em>in der Sidebar</em> w&auml;hlen, so werden die Zitate automatisch angezeigt, ohne da&szlig; Sie ein Template &auml;ndern m&uuml;ssen.
     </span>     
   </fieldset>
   <fieldset>
    <legend>Weitere Optionen</legend>
    <input type="checkbox" name="ueberschrift" id="ueberschrift" value="1" '.(($this->_ueberschrift) ? ' checked="checked"' : '').'/> <label for="ueberschrift">&Uuml;berschrift "<strong>Zitat des Tages</strong>" bzw. "<strong>Zufallszitat</strong>" anzeigen.</label><br/>
    <span style="font-size:90%;">
     Wenn Sie diese Option w&auml;hlen wird &uuml;ber dem Zitat eine entsprechende &Uuml;berschrift (&lt;h2&gt;) angezeigt.<br />
    </span>
    <input type="checkbox" name="autorbild" id="autorbild" value="1" '.(($this->_autorbild) ? ' checked="checked"' : '').'/> <label for="ueberschrift">Bild des Zitat-Autors anzeigen</label><br/>
   </fieldset>
   <fieldset> 
     <legend>Einstellungen speichern</legend> 
     <input type="submit" name="speichern" value="Speichern"/>
   </fieldset>
  </form>
 
 ';
 }

}

$www_zitate_online_de_objekt = new www_zitate_online_de();
function www_zitate_online_de_zitat() {
 global $www_zitate_online_de_objekt;
  $www_zitate_online_de_objekt->textanzeige_manuell();
}

?>